﻿unit DingUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, JvComponentBase, JvTrayIcon, MPlayer, ExtCtrls, StdCtrls, Spin,
  JvTimer, JvThreadTimer, dxfTimer, INIFiles, Menus, ActnList, Buttons;

type
  TfrmDing = class(TForm)
    dingTrayIcon: TJvTrayIcon;
    dingMediaPlayer: TMediaPlayer;
    dingEdit: TSpinEdit;
    Label1: TLabel;
    Label3: TLabel;
    dingTimer: TdxfTimer;
    Label6: TLabel;
    edMaxim: TSpinEdit;
    dingAction: TActionList;
    dingPopupMenu: TPopupMenu;
    Cmd_Close: TAction;
    Clsoe1: TMenuItem;
    Cmd_Show: TAction;
    CmdShow1: TMenuItem;
    Cmd_SaveSettings: TAction;
    CmdSaveSettings1: TMenuItem;
    Cmd_Hide: TAction;
    CmdHide1: TMenuItem;
    GroupBox1: TGroupBox;
    radioRepetitiv: TRadioButton;
    radioRandom: TRadioButton;
    btnSaveSettings: TSpeedButton;
    btnApply: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure dingTimerEndOfTime(Sender: TdxfTimer);
    procedure btnApplyClick(Sender: TObject);
    procedure Cmd_CloseExecute(Sender: TObject);
    procedure Cmd_ShowExecute(Sender: TObject);
    procedure Cmd_SaveSettingsExecute(Sender: TObject);
    procedure Cmd_HideExecute(Sender: TObject);
    procedure btnSaveSettingsClick(Sender: TObject);
    procedure dingEditExit(Sender: TObject);
    procedure dingMediaPlayerClick(Sender: TObject; Button: TMPBtnType;
      var DoDefault: Boolean);
  private
    { Private declarations }
    procedure EventHide (var aMessage : TMessage); message WM_USER+1;
    procedure LoadFromINI;
    procedure SaveToINI;
  public
    { Public declarations }

  end;

procedure ExtractFileFromResource(const _ResourceName, _Filename: string);
function ExeVersion : string;

var
  frmDing          : TfrmDing;
  ExeVerStr        : String;

implementation

{$R *.dfm}


procedure ExtractFileFromResource(const _ResourceName, _Filename: string);
var
  ResStream: TResourceStream;
  FileStream: TFileStream;
begin
  ResStream := TResourceStream.Create(HInstance, _ResourceName, RT_RCDATA);
  try
    FileStream := TFileStream.Create(_Filename, fmCreate);
    try
      FileStream.CopyFrom(ResStream, 0);
    finally
      FileStream.Free;
    end;
  finally
    ResStream.Free;
  end;
end;


procedure TfrmDing.FormCreate(Sender: TObject);
var lDir : string;
    aInterval : Integer;
    aSign : Integer;
begin
  Caption := Caption + ' '+ExeVersion;
  dingMediaPlayer.Notify := True;
  Randomize;
  LoadFromINI;
  dingMediaPlayer.Wait := False;
  dingTrayIcon.Active := True;
  PostMessage(Handle,WM_USER+1,0,0);
  lDir := IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0)));
  ExtractFileFromResource('ding_melody',lDir+'bowl.mp3');
  dingMediaPlayer.FileName := lDir+'bowl.mp3';
  dingMediaPlayer.Open;
  //dingMediaPlayer.Play;
  dingMediaPlayer.EnabledButtons := [btStop,btPause,btPlay];
  if radioRandom.Checked then begin
    aInterval := Random(edMaxim.Value);
    if aInterval mod 2 = 0 then  aSign := 1
    else aSign := -1;
    aInterval := dingEdit.Value+aSign*aInterval;
  end
  else
    aInterval := dingEdit.Value;
  dingTimer.EndMin := aInterval;
  //dingEdit.Value := aInterval;
  dingTimer.Start;
end;

procedure TfrmDing.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SaveToINI;
  Action := caNone;
  //CmdShow1.Visible := not CmdShow1.Visible;
  //CmdHide1.Visible := not CmdHide1.Visible;
  PostMessage(Handle,WM_USER+1,0,0);
end;

procedure TfrmDing.EventHide(var aMessage: TMessage);
begin
  dingTrayIcon.HideApplication;
//  Hide;
end;

procedure TfrmDing.dingTimerEndOfTime(Sender: TdxfTimer);
var aInterval,aSign : Integer;
begin
  if radioRandom.Checked then begin
    aInterval := Random(edMaxim.Value);
    if aInterval mod 2 = 0 then  aSign := 1
    else aSign := -1;
    aInterval := dingEdit.Value+aSign*aInterval;
  end
  else
    aInterval := dingEdit.Value;
  dingTimer.EndMin := aInterval;
  {
  if radioRandom.Checked then begin
    aInterval := edMinim.Value+Random(edMaxim.Value);
    dingTimer.EndMin := aInterval;
  end
  else begin
    aInterval := dingEdit.Value;
    dingTimer.EndMin := aInterval;
  end;
  }
  dingMediaPlayer.Stop;
  dingMediaPlayer.Play;
  dingTimer.Stop;
  dingTimer.Start;
end;

procedure TfrmDing.btnApplyClick(Sender: TObject);
var aInterval,aSign : Integer;
begin
  dingTimer.Reset;
  if radioRandom.Checked then begin
    aInterval := Random(edMaxim.Value);
    if aInterval mod 2 = 0 then  aSign := 1
    else aSign := -1;
    aInterval := dingEdit.Value+aSign*aInterval;
  end
  else
    aInterval := dingEdit.Value;
  dingTimer.EndMin := aInterval;
  dingTimer.Start;
end;

procedure TfrmDing.LoadFromINI;
var aFile : TIniFile;
    lDir : string;
begin
  lDir := IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0)));
  aFile :=  TIniFile.Create(lDir+'ding.ini');
  //edMinim.Value := aFile.ReadInteger('TIME','MinTime',21);
  edMaxim.Value := aFile.ReadInteger('TIME','MaxTime',900);
  if aFile.ReadInteger('TIME','PlayMode',2)=2 then begin
    radioRepetitiv.Checked := True;
    end
  else
    radioRandom.Checked := True;
  dingEdit.Value := aFile.ReadInteger('TIME','Interval',1);    
  aFile.Free;
end;

procedure TfrmDing.SaveToINI;
var aFile : TIniFile;
    lDir : string;
begin
  lDir := IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0)));
  aFile :=  TIniFile.Create(lDir+'ding.ini');
  //aFile.WriteInteger('TIME','MinTime',edMinim.Value);
  aFile.WriteInteger('TIME','MaxTime',edMaxim.Value);
  if radioRandom.Checked then begin
    aFile.WriteInteger('TIME','PlayMode',1);
    //aFile.WriteInteger('TIME','Interval',0);
  end
  else begin
    aFile.WriteInteger('TIME','PlayMode',2);
  end;
  aFile.WriteInteger('TIME','Interval',dingEdit.Value);  
  aFile.Free;
end;

procedure TfrmDing.Cmd_CloseExecute(Sender: TObject);
begin
  dingMediaPlayer.Close;
  Application.Terminate;
end;

procedure TfrmDing.Cmd_ShowExecute(Sender: TObject);
begin
  dingTrayIcon.ApplicationVisible := not  dingTrayIcon.ApplicationVisible;
{  if frmDing.Visible then
    PostMessage(Handle,WM_USER+1,0,0)
  else
    dingTrayIcon.ShowApplication;}
  //CmdShow1.Visible := False;
  //CmdHide1.Visible := True;
//  Show;
end;

procedure TfrmDing.Cmd_SaveSettingsExecute(Sender: TObject);
begin
   SaveToINI;
end;

procedure TfrmDing.Cmd_HideExecute(Sender: TObject);
begin
  CmdShow1.Visible := True;
  CmdHide1.Visible := False;
  PostMessage(Handle,WM_USER+1,0,0);
end;

procedure TfrmDing.btnSaveSettingsClick(Sender: TObject);
begin
   SaveToINI;
end;

procedure TfrmDing.dingEditExit(Sender: TObject);
begin
  if dingEdit.Value < 1 then
    dingEdit.Value := 1;
  dingTimer.Reset;
  dingTimer.EndMin := dingEdit.Value;
  dingTimer.Start;
end;

procedure TfrmDing.dingMediaPlayerClick(Sender: TObject;
  Button: TMPBtnType; var DoDefault: Boolean);
begin
  DoDefault := False;

  case Button of
    btPlay : begin
      dingMediaPlayer.Play;
      dingMediaPlayer.EnabledButtons := [btStop,btPause];      
    end;
    btStop : begin
      dingMediaPlayer.Stop;
      dingMediaPlayer.Rewind;
      dingMediaPlayer.EnabledButtons := [btStop,btPause,btPlay];
    end;
    btPause : begin
      dingMediaPlayer.Pause;
      dingMediaPlayer.EnabledButtons := [btStop,btPause,btPlay];      
    end;
  end;
end;

function ExeVersion: String;
var ExePChar  : PChar;
    aHandle   : DWord;
    aSize     : Integer;
    lpData    : Pointer;
    lpBuffer  : Pointer;
    lpSize    : DWord;
    LangStr   : String;
    LangId    : DWord;
begin
  if ExeVerStr = '' then begin
     ExePChar := PChar(ParamStr(0));
     aSize := GetFileVersionInfoSize(ExePChar, aHandle);
     if aSize = 0 then Exit;//RaiseLastWin32Error;
     lpData := AllocMem(aSize);
     try
       if not GetFileVersionInfo(ExePChar, 0, aSize, lpData) then
          Exit;//Abort;
       if not VerQueryValue(lpData, '\VarFileInfo\Translation', lpBuffer, lpSize) then
          Exit;//Abort;
       LangId  := PDWord(lpBuffer)^;
       LangStr := Format('%.4x%.4x',[LangId and $0FFFF,LangId shr 16]);
       if not VerQueryValue(lpData, PChar('\StringFileInfo\'+LangStr+'\FileVersion'), lpBuffer, lpSize) then
          Exit;//Abort;
       ExeVerStr := StrPas(PChar(lpBuffer));
     finally
       FreeMem(lpData, aSize);
     end;
  end;
  Result := ExeVerStr;
end;



end.
